
#include "LPC43xx.h"


/* Define FPB registers */
typedef struct {
    __IO uint32_t CTRL;
    __IO uint32_t REMAP;
    __IO uint32_t CODE_COMP[6];
    __IO uint32_t LIT_COMP[2];
} FPB_Type;

#define FPB ((FPB_Type *)0xE0002000)



int main (void)
{
    volatile int i;

    for (i = 0; i < 10000000; i++)
        ;

    /* Reset as many peripherals as possible. */
    LPC_RGU->RESET_CTRL0 = 0x387F1200;
    LPC_RGU->RESET_CTRL1 = 0x17FFF7FF;


    /* Patch the boot ROM: @0x10401A04: Overwrite boot pins: Always return USB0 as the boot source.    */
	/* This only works with the boot ROM in LPC1857/4357 !!                                            */
	/* The boot ROM in LPC1850/4350 is different, so the patch needs to be done on a different address */
	
    FPB->REMAP = 0x20000000;                    /* REMAP table @ 0x20000000 */
    ((volatile uint32_t *)0x20000000)[0] = 0x20152015;  /* movs r0,#0x15 (2x) */
    FPB->CODE_COMP[0] = 0x10401A04 | 0x00000001;
    FPB->CTRL = 0x00000003;                     /* Enable FPB unit */

    LPC_CREG->CREG6 &= ~(1u << 17);             /* RNG clock */

    ((void(*)(int))0x1040214D)(LPC_OTP_BASE);   // Clocks_Init
    ((void(*)(int))0x104021C1)(LPC_OTP_BASE);   // tmBootRomConfig_Clocks_and_Pins
    ((void(*)(int))0x104038DF)(LPC_OTP_BASE);   // tmBootRomISP_init
    ((void(*)(int))0x104038F3)(LPC_OTP_BASE);   // tmBootRomISP_run

    while (1)
        ;
}

