
#if defined(CORE_M4)

/* External functions */
extern int __main (void);
extern void SystemInit (void);


/* Default interrupt service routines.
 * Defined as weak symbols. Can be redefined in the application.
 */
#define ALIAS(def) __attribute__((weak,alias(#def)))

void Default_IRQHandler (void);

void Reset_Handler (void);
void NMI_Handler (void) ALIAS(_NMI_Handler);
void HardFault_Handler (void) ALIAS(_HardFault_Handler);
void MPU_Handler (void) ALIAS(_MPU_Handler);
void BusFault_Handler (void) ALIAS(_BusFault_Handler);
void SVC_Handler (void) ALIAS(_SVC_Handler);
void DebugMon_Handler (void) ALIAS(_DebugMon_Handler);
void UsageFault_Handler (void) ALIAS(_UsageFault_Handler);
void PendSV_Handler (void) ALIAS(_PendSV_Handler);
void SysTick_Handler (void) ALIAS(_SysTick_Handler);

extern void __initial_sp;
extern int Image$$ARM_LIB_STACK$$ZI$$Limit;

void DAC_IRQHandler (void) ALIAS(Default_IRQHandler);
void M0_IRQHandler (void) ALIAS(Default_IRQHandler);
void DMA_IRQHandler (void) ALIAS(Default_IRQHandler);
void FLASH_EEPROM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ETH_IRQHandler (void) ALIAS(Default_IRQHandler);
void SDIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void LCD_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB0_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SCT_IRQHandler (void) ALIAS(Default_IRQHandler);
void RIT_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER1_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER2_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER3_IRQHandler (void) ALIAS(Default_IRQHandler);
void MCPWM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPI_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP0_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART0_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART2_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART3_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPIFI_IRQHandler (void) ALIAS(Default_IRQHandler);
void SGPIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO1_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO2_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO3_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO4_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO5_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO6_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO7_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT1_IRQHandler (void) ALIAS(Default_IRQHandler);
void EVRT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN1_IRQHandler (void) ALIAS(Default_IRQHandler);
void VADC_IRQHandler (void) ALIAS(Default_IRQHandler);
void ATIMER_IRQHandler (void) ALIAS(Default_IRQHandler);
void RTC_IRQHandler (void) ALIAS(Default_IRQHandler);
void WWDT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN0_IRQHandler (void) ALIAS(Default_IRQHandler);
void QEI_IRQHandler (void) ALIAS(Default_IRQHandler);



#define SIGN_VALUE      0x5A5A5A5A



/** Vector table.
 */
void (* const vector_table[])(void) __attribute__ ((section("RESET"))) =
{
#if defined (__CC_ARM) && defined(__MICROLIB)
    (void(*)(void)) &__initial_sp,
#else
    (void(*)(void)) &Image$$ARM_LIB_STACK$$ZI$$Limit,
#endif
    Reset_Handler,
    NMI_Handler,
    HardFault_Handler,
    MPU_Handler,
    BusFault_Handler,
    UsageFault_Handler,
    (void(*)(void)) SIGN_VALUE,
    0,
    0,
    0,
    SVC_Handler,
    DebugMon_Handler,
    0,
    PendSV_Handler,
    SysTick_Handler,

    DAC_IRQHandler,                         /* 16 */
    M0_IRQHandler,                          /* 17 */
    DMA_IRQHandler,                         /* 18 */
    0,
    FLASH_EEPROM_IRQHandler,                /* 20 Reserved for Typhoon */
    ETH_IRQHandler,                         /* 21 Ethernet */
    SDIO_IRQHandler,                        /* 22 SD/MMC */
    LCD_IRQHandler,                         /* 23 LCD */
    USB0_IRQHandler,                        /* 24 USB0 */
    USB1_IRQHandler,                        /* 25 USB1 */
    SCT_IRQHandler,                         /* 26 State Configurable Timer */
    RIT_IRQHandler,                         /* 27 Repetitive Interrupt Timer */
    TIMER0_IRQHandler,                      /* 28 Timer0 */
    TIMER1_IRQHandler,                      /* 29 Timer1 */
    TIMER2_IRQHandler,                      /* 30 Timer2 */
    TIMER3_IRQHandler,                      /* 31 Timer3 */
    MCPWM_IRQHandler,                       /* 32 Motor Control PWM */
    ADC0_IRQHandler,                        /* 33 A/D Converter 0 */
    I2C0_IRQHandler,                        /* 34 I2C0 */
    I2C1_IRQHandler,                        /* 35 I2C1 */
    SPI_IRQHandler,                         /* 36 SPI */
    ADC1_IRQHandler,                        /* 37 A/D Converter 1 */
    SSP0_IRQHandler,                        /* 38 SSP0 */
    SSP1_IRQHandler,                        /* 39 SSP1 */
    UART0_IRQHandler,                       /* 40 UART0 */
    UART1_IRQHandler,                       /* 41 UART1 */
    UART2_IRQHandler,                       /* 42 UART2 */
    UART3_IRQHandler,                       /* 43 UART3 */
    I2S0_IRQHandler,                        /* 44 I2S0 */
    I2S1_IRQHandler,                        /* 45 I2S1 */
    SPIFI_IRQHandler,                       /* 46 SPI Flash Interface */
    SGPIO_IRQHandler,                       /* 47 SGPIO */
    GPIO0_IRQHandler,                       /* 48 GPIO0 */
    GPIO1_IRQHandler,                       /* 49 GPIO1 */
    GPIO2_IRQHandler,                       /* 50 GPIO2 */
    GPIO3_IRQHandler,                       /* 51 GPIO3 */
    GPIO4_IRQHandler,                       /* 52 GPIO4 */
    GPIO5_IRQHandler,                       /* 53 GPIO5 */
    GPIO6_IRQHandler,                       /* 54 GPIO6 */
    GPIO7_IRQHandler,                       /* 55 GPIO7 */
    GINT0_IRQHandler,                       /* 56 GINT0 */
    GINT1_IRQHandler,                       /* 57 GINT1 */
    EVRT_IRQHandler,                        /* 58 Event Router */
    CAN1_IRQHandler,                        /* 59 C_CAN1 */
    0,
    VADC_IRQHandler,                        /* 61 VADC */
    ATIMER_IRQHandler,                      /* 62 ATIMER */
    RTC_IRQHandler,                         /* 63 RTC */
    0,
    WWDT_IRQHandler,                        /* 65 WWDT */
    0,
    CAN0_IRQHandler,                        /* 67 C_CAN0 */
    QEI_IRQHandler,                         /* 68 QEI */
};



__attribute__ ((section("CRP")))
const unsigned long CRP_Key = 0xFFFFFFFF;


void Reset_Handler (void)
{
    SystemInit();   /* Globals not yet initialized!! */

    /* Jump to the library entry point __main() */
    __main();

    /* Loop here forever, in case main() ever returns. */
    while (1)
        ;
}




static void _NMI_Handler (void)
{
    while (1)
        ;
}

static void _HardFault_Handler (void)
{
    while (1)
        ;
}

static void _MPU_Handler (void)
{
    while (1)
        ;
}

static void _BusFault_Handler (void)
{
    while (1)
        ;
}

static void _UsageFault_Handler (void)
{
    while (1)
        ;
}

static void _PendSV_Handler (void)
{
    while (1)
        ;
}

static void _SysTick_Handler (void)
{
    while (1)
        ;
}

static void _SVC_Handler (void)
{
    while (1)
        ;
}

static void _DebugMon_Handler (void)
{
    while (1)
        ;
}

void Default_IRQHandler (void)
{
    while (1)
        ;
}



#if defined (__CC_ARM) && !defined(__MICROLIB)
__asm void __user_setup_stackheap (void)
{
    IMPORT  |Image$$ARM_LIB_HEAP$$ZI$$Base|
    IMPORT  |Image$$ARM_LIB_HEAP$$ZI$$Limit|
    IMPORT  |Image$$ARM_LIB_STACK$$ZI$$Base|

    ldr     r0, =|Image$$ARM_LIB_HEAP$$ZI$$Base|
    ldr     r2, =|Image$$ARM_LIB_HEAP$$ZI$$Limit|
    ldr     r3, =|Image$$ARM_LIB_STACK$$ZI$$Base|
    
    bx      lr
  ALIGN
}
#endif

#endif






#if defined(CORE_M0)

/* External functions */
extern int __main (void);
extern void SystemInit (void);


/* Default interrupt service routines.
 * Defined as weak symbols. Can be redefined in the application.
 */
#define ALIAS(def) __attribute__((weak,alias(#def)))

void Default_IRQHandler (void);

void Reset_Handler (void);
void NMI_Handler (void) ALIAS(_NMI_Handler);
void HardFault_Handler (void) ALIAS(_HardFault_Handler);
void Sign_Value (void);
void SVC_Handler (void) ALIAS(_SVC_Handler);
void DebugMon_Handler (void) ALIAS(_DebugMon_Handler);
void PendSV_Handler (void) ALIAS(_PendSV_Handler);
void SysTick_Handler (void) ALIAS(_SysTick_Handler);

extern void Image$$ARM_LIB_STACK$$ZI$$Limit;

void DAC_IRQHandler (void) ALIAS(Default_IRQHandler);
void M4_IRQHandler (void) ALIAS(Default_IRQHandler);
void DMA_IRQHandler (void) ALIAS(Default_IRQHandler);
void FLASH_EEPROM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ETH_IRQHandler (void) ALIAS(Default_IRQHandler);
void SDIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void LCD_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB0_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SCT_IRQHandler (void) ALIAS(Default_IRQHandler);
void RIT_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER1_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER2_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER3_IRQHandler (void) ALIAS(Default_IRQHandler);
void MCPWM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPI_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP0_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART0_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART2_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART3_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPIFI_IRQHandler (void) ALIAS(Default_IRQHandler);
void SGPIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO1_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO2_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO3_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO4_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO5_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO6_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO7_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT1_IRQHandler (void) ALIAS(Default_IRQHandler);
void EVRT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN1_IRQHandler (void) ALIAS(Default_IRQHandler);
void VADC_IRQHandler (void) ALIAS(Default_IRQHandler);
void ATIMER_IRQHandler (void) ALIAS(Default_IRQHandler);
void RTC_IRQHandler (void) ALIAS(Default_IRQHandler);
void WDT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN0_IRQHandler (void) ALIAS(Default_IRQHandler);
void QEI_IRQHandler (void) ALIAS(Default_IRQHandler);



#define SIGN_VALUE      0x5A5A5A5A



/** Vector table.
 */
void (* const vector_table[])(void) __attribute__ ((section("RESET"))) =
{
    (void(*)(void)) &Image$$ARM_LIB_STACK$$ZI$$Limit,
    Reset_Handler,
    NMI_Handler,
    HardFault_Handler,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    SVC_Handler,
    DebugMon_Handler,
    0,
    PendSV_Handler,
    SysTick_Handler,

    RTC_IRQHandler,
    M4_IRQHandler,
    DMA_IRQHandler,
    0,
    0,
    ETH_IRQHandler,                         /* 21 Ethernet */
    SDIO_IRQHandler,                        /* 22 SD/MMC */
    LCD_IRQHandler,                         /* 23 LCD */
    USB0_IRQHandler,                        /* 24 USB0 */
    USB1_IRQHandler,                        /* 25 USB1 */
    SCT_IRQHandler,                         /* 26 State Configurable Timer */
    RIT_IRQHandler,                         /* 27 Repetitive Interrupt Timer */ //TODO WWDT optional
    TIMER0_IRQHandler,                      /* 28 Timer0 */
    GINT1_IRQHandler,
    TIMER3_IRQHandler,
    0,
    0,
    MCPWM_IRQHandler,                       /* 32 Motor Control PWM */
    ADC0_IRQHandler,                        /* 33 A/D Converter 0 */
    I2C0_IRQHandler,                        /* 34 I2C0 */ //TODO Optional I2C1
    SGPIO_IRQHandler,                       /* 47 SGPIO */
    SPI_IRQHandler,                         /* 36 SPI */ //optional DAC
    ADC1_IRQHandler,                        /* 37 A/D Converter 1 */
    SSP0_IRQHandler,                        /* 38 SSP0 */ //TODO optional SSP1
    EVRT_IRQHandler,                        /* 58 Event Router */
    UART0_IRQHandler,                       /* 40 UART0 */
    UART2_IRQHandler,                       /* 42 UART2 */ //TODO optinbal CAN1
    UART3_IRQHandler,
    I2S0_IRQHandler,                        /* 44 I2S0 */ //TODO optional I2S1 or QEI
    CAN0_IRQHandler,
};


void Reset_Handler (void)
{
    SystemInit();   /* Globals not yet initialized!! */

    /* Jump to the library entry point __main() */
    __main();

    /* Loop here forever, in case main() ever returns. */
    while (1) {
    }
}




void _NMI_Handler (void)
{
    while (1)
        ;
}

void _HardFault_Handler (void)
{
    while (1)
        ;
}

void _PendSV_Handler (void)
{
    while (1)
        ;
}

void _SysTick_Handler (void)
{
    while (1)
        ;
}

void _SVC_Handler (void)
{
    while (1)
        ;
}

void _DebugMon_Handler (void)
{
    while (1)
        ;
}

void Default_IRQHandler (void)
{
    while (1)
        ;
}



#if defined (__CC_ARM) && !defined(__MICROLIB)
__asm void __user_setup_stackheap (void)
{
    IMPORT  |Image$$ARM_LIB_HEAP$$ZI$$Base|
    IMPORT  |Image$$ARM_LIB_HEAP$$ZI$$Limit|
    IMPORT  |Image$$ARM_LIB_STACK$$ZI$$Base|

    ldr     r0, =|Image$$ARM_LIB_HEAP$$ZI$$Base|
    ldr     r2, =|Image$$ARM_LIB_HEAP$$ZI$$Limit|
    ldr     r3, =|Image$$ARM_LIB_STACK$$ZI$$Base|
    
    bx      lr
  ALIGN
}
#endif

#endif

